
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>对存储过程进行加密和解密(SQL 2008/SQL 2012) / iVAN</title>

    <meta name="description" content="对存储过程进行加密和解密(SQL 2008/SQL 2012) 原文 http://www.cnblogs.com/wghao/archive/2012/12/30/2837642.html 开始:  在网络上,看到有SQL Server 2000和SQL Server 2005 的存储过程加密和解密的方法,后来分析了其中的代码,发现它们的原理都是一样的.后来自己根据实际的应用环境,编写了两个存储过程,一个加密存储过程 (sp_EncryptObject),和一个解密存储过程(sp_EncryptObject),它们可以应用于SQL Server中的储过程,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">对存储过程进行加密和解密(SQL 2008/SQL 2012)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文 <a href="http://www.cnblogs.com/wghao/archive/2012/12/30/2837642.html" rel="external nofollow noreferrer">http://www.cnblogs.com/wghao/archive/2012/12/30/2837642.html</a></p>
<p><strong>开始：</strong></p>
<hr>
<br /> 在网络上，看到有SQL Server 2000和SQL Server 2005 的存储过程加密和解密的方法，后来分析了其中的代码，发现它们的原理都是一样的。后来自己根据实际的应用环境，编写了两个存储过程，一个加密存储过程 （sp_EncryptObject），和一个解密存储过程（sp_EncryptObject），它们可以应用于SQL Server中的储过程，函数，视图，以及触发器。</p>
<p>感觉这两个存储过程蛮有意思的，拿来与大家分享；如果你看过类似的，就当作重温一下也好。</p>
<p> </p>
<p><strong>用于加密的存储过程 （sp_EncryptObject） ：</strong></p>
<hr>
<br /> 存储过程（sp_EncryptObject）加密的方法是在存储过程，函数，视图的“As”位置前加上“with encryption”；如果是触发器，就在“for”位置前加“with encryption”。</p>
<p>如果触发器是{ AFTER | INSTEAD OF} 需要修改下面代码"For"位置：</p>
<pre>if objectproperty(object_id(@Object),'ExecIsAfterTrigger')=0 set @Replace='As' ; else set @Replace='For ';</pre>
<p>存储过程完成代码：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">View Code</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>Use master
Go
if object_ID('[sp_EncryptObject]') is not null
    Drop Procedure [sp_EncryptObject]
Go
create procedure sp_EncryptObject
(
    @Object sysname='All'
)
as
/*
    当@Object=All的时候，对所有的函数，存储过程，视图和触发器进行加密
    调用方法：
    1. Execute sp_EncryptObject 'All'
    2. Execute sp_EncryptObject 'ObjectName'
*/
begin
    set nocount on

    if @Object &lt;&gt;'All'
    begin
        if not exists(select 1 from sys.objects a where a.object_id=object_id(@Object) And a.type in('P','V','TR','FN','IF','TF'))
        begin
            --SQL Server 2008
            raiserror 50001 N'无效的加密对象！加密对象必须是函数，存储过程，视图或触发器。'

            --SQL Server 2012
            --throw 50001, N'无效的加密对象！加密对象必须是函数，存储过程，视图或触发器。',1  

            return
        end

        if exists(select 1 from sys.sql_modules a where a.object_id=object_id(@Object) and a.definition is null)
        begin
            --SQL Server 2008
            raiserror 50001 N'对象已经加密！'

            --SQL Server 2012
            --throw 50001, N'对象已经加密！',1
            return
        end
    end

    declare @sql nvarchar(max),@C1 nchar(1),@C2 nchar(1),@type nvarchar(50),@Replace nvarchar(50)
    set @C1=nchar(13)
    set @C2=nchar(10)

    declare cur_Object
        cursor for
            select object_name(a.object_id) As ObjectName,a.definition
                from sys.sql_modules a
                    inner join sys.objects b on b.object_id=a.object_id
                        and b.is_ms_shipped=0
                        and not exists(select 1
                                            from sys.extended_properties x
                                            where x.major_id=b.object_id
                                                and x.minor_id=0
                                                and x.class=1
                                                and x.name='microsoft_database_tools_support'
                                        )
                where b.type in('P','V','TR','FN','IF','TF')
                    and (b.name=@Object or @Object='All')
                    and b.name &lt;&gt;'sp_EncryptObject'
                    and a.definition is not null
                order by Case
                            when b.type ='V' then 1
                            when b.type ='TR' then 2
                            when b.type in('FN','IF','TF') then 3
                            else 4 end,b.create_date,b.object_id

    open cur_Object
    fetch next from cur_Object into @Object,@sql
    while @@fetch_status=0
    begin

        Begin Try

            if objectproperty(object_id(@Object),'ExecIsAfterTrigger')=0 set @Replace='As' ; else set @Replace='For ';

            if (patindex('%'+@C1+@C2+@Replace+@C1+@C2+'%',@sql)&gt;0)
            begin
                set @sql=Replace(@sql,@C1+@C2+@Replace+@C1+@C2,@C1+@C2+'With Encryption'+@C1+@C2+@Replace+@C1+@C2)
            end
            else if(patindex('%'+@C1+@Replace+@C1+'%',@sql)&gt;0)
            begin
                set @sql=Replace(@sql,@C1+@Replace+@C1,@C1+'With Encryption'+@C1+@Replace+@C1)
            end
            else if(patindex('%'+@C2+@Replace+@C2+'%',@sql)&gt;0)
            begin
                set @sql=Replace(@sql,@C2+@Replace+@C2,@C2+'With Encryption'+@C2+@Replace+@C2)
            end
            else if(patindex('%'+@C2+@Replace+@C1+'%',@sql)&gt;0)
            begin
                set @sql=Replace(@sql,@C2+@Replace+@C1,@C1+'With Encryption'+@C2+@Replace+@C1)
            end
            else if(patindex('%'+@C1+@C2+@Replace+'%',@sql)&gt;0)
            begin
                set @sql=Replace(@sql,@C1+@C2+@Replace,@C1+@C2+'With Encryption'+@C1+@C2+@Replace)
            end
            else if(patindex('%'+@C1+@Replace+'%',@sql)&gt;0)
            begin
                set @sql=Replace(@sql,@C1+@Replace,@C1+'With Encryption'+@C1+@Replace)
            end
            else if(patindex('%'+@C2+@Replace+'%',@sql)&gt;0)
            begin
                set @sql=Replace(@sql,@C2+@Replace,@C2+'With Encryption'+@C2+@Replace)
            end

            set @type =
                case
                    when object_id(@Object,'P')&gt;0 then 'Proc'
                    when object_id(@Object,'V')&gt;0 then 'View'
                    when object_id(@Object,'TR')&gt;0  then 'Trigger'
                    when object_id(@Object,'FN')&gt;0 or object_id(@Object,'IF')&gt;0 or object_id(@Object,'TF')&gt;0 then 'Function'
                end
            set @sql=Replace(@sql,'Create '+@type,'Alter '+@type)

            Begin Transaction
            exec(@sql)
            print N'已完成加密对象('+@type+')：'+@Object
            Commit Transaction

        End Try
        Begin Catch
            Declare @Error nvarchar(2047)
            Set @Error='Object: '+@Object+@C1+@C2+'Error: '+Error_message()

            Rollback Transaction
            print @Error
            print @sql
        End Catch

        fetch next from cur_Object into @Object,@sql

    end

    close cur_Object
    deallocate cur_Object
end

Go
exec sp_ms_marksystemobject 'sp_EncryptObject' --标识为系统对象
go</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>如果SQL Server 2012，请修改下面两个位置的代码。在SQL Server 2012，建议在使用throw来代替raiserror。</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ184MjZjNmIzYmMxMGRmNmQzN2JkNDRlMjdkOTE1ZDg3Ny5qcGc=.jpg"></p>
<p> </p>
<p> </p>
<p><strong>解密方法：</strong></p>
<hr>
<br /> 解密过程，最重要采用异或方法：</p>
<p>[字符1]经过函数 fn_x（x）加密变成[加密后字符1]，如果我们已知[加密后字符1]，反过来查[字符1],可以这样：</p>
<p>[字符1]  =  [字符2]  ^  fn_x([字符2])  ^  [加密后字符1]</p>
<p> </p>
<p>这里我列举一个简单的例子：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>--创建加密函数（fn_x）
if object_id('fn_x') is not null drop function fn_x
go
create function fn_x
(
    @x nchar(1)
)returns nchar(1)
as
begin
return(nchar((65535-unicode(@x))))
end
go
declare @nchar_1_encrypt nchar(1),@nchar_2 nchar(1)

--对字符'A'进行加密，存入变量@nchar_1_encrypt
set @nchar_1_encrypt=dbo.fn_x(N'A') 

--參考的字符@nchar_2
set @nchar_2='x' 

--算出@nchar_1_encrypt 加密前的字符
select nchar(unicode(@nchar_2)^unicode(dbo.fn_x(@nchar_2))^unicode(@nchar_1_encrypt)) as [@nchar_1]

/*
@nchar_1
--------------------
A
*/</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p> </p>
<p><strong>[注]：  </strong>从SQL Server 2000至 SQL Server 2012 采用异或方法都可以解密</p>
<p> </p>
<p><strong>用于解密的存储过程（sp_DecryptObject）：</strong></p>
<hr>
<br /> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">View Code</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>Use master
Go
if object_ID('[sp_DecryptObject]') is not null
    Drop Procedure [sp_DecryptObject]
Go
create procedure sp_DecryptObject
(
    @Object sysname,    --要解密的对象名：函数，存储过程，视图或触发器
    @MaxLength int=4000 --评估内容的长度
)
as
set nocount on
/* 1. 解密 */

if not exists(select 1 from sys.objects a where a.object_id=object_id(@Object) And a.type in('P','V','TR','FN','IF','TF'))
begin
    --SQL Server 2008
    raiserror 50001 N'无效的对象！要解密的对象必须是函数，存储过程，视图或触发器。' 

    --SQL Server 2012
    --throw 50001, N'无效的对象！要解密的对象必须是函数，存储过程，视图或触发器。',1
    return
end

if exists(select 1 from sys.sql_modules a where a.object_id=object_id(@Object) and a.definition is not null)
begin
    --SQL Server 2008
    raiserror 50001 N'对象没有加密！' 

    --SQL Server 2012
    --throw 50001, N'无效的对象！要解密的对象必须是函数，存储过程，视图或触发器。',1
    return
end

declare  @sql nvarchar(max)                --解密出来的SQL语句
        ,@imageval nvarchar(max)        --加密字符串
        ,@tmpStr nvarchar(max)            --临时SQL语句
        ,@tmpStr_imageval nvarchar(max) --临时SQL语句(加密后)
        ,@type char(2)                    --对象类型('P','V','TR','FN','IF','TF')
        ,@objectID int                    --对象ID
        ,@i int                            --While循环使用
        ,@Oject1 nvarchar(1000)

set @objectID=object_id(@Object)
set @type=(select a.type from sys.objects a where a.object_id=@objectID)

declare @Space4000 nchar(4000)
set @Space4000=replicate('-',4000)

/*
@tmpStr 会构造下面的SQL语句
-------------------------------------------------------------------------------
alter trigger Tr_Name on Table_Name with encryption for update as return /**/
alter proc Proc_Name with encryption  as select 1 as col /**/
alter view View_Name with encryption as select 1 as col /**/
alter function Fn_Name() returns int with encryption as begin return(0) end/**/
*/
set @Oject1=quotename(object_schema_name(@objectID))+'.'+quotename(@Object)
set @tmpStr=
        case
            when @type ='P ' then N'Alter Procedure '+@Oject1+' with encryption as select 1 as column1 '
            when @type ='V ' then N'Alter View '+@Oject1+' with encryption as select 1 as column1 '
            when @type ='FN' then N'Alter Function '+@Oject1+'() returns int with encryption as begin return(0) end '
            when @type ='IF' then N'Alter Function '+@Oject1+'() returns table with encryption as return(Select a.name from sys.types a) '
            when @type ='TF' then N'Alter Function '+@Oject1+'() returns @t table(name nvarchar(50)) with encryption as begin return end '
            else 'Alter Trigger '+@Oject1+'on '+quotename(object_schema_name(@objectID))+'.'+(select Top(1) quotename(object_name(parent_id)) from sys.triggers a where a.object_id=@objectID)+' with encryption for update as return '
        end        

set @tmpStr=@tmpStr+'/*'+@Space4000
set @i=0
while @i &lt; (ceiling(@MaxLength*1.0/4000)-1)
begin
    set @tmpStr=@tmpStr+ @Space4000
    Set @i=@i+1
end
set @tmpStr=@tmpStr+'*/'

------------
set @imageval =(select top(1) a.imageval from sys.sysobjvalues a where a.objid=@objectID and a.valclass=1)

begin tran
exec(@tmpStr)
set @tmpStr_imageval =(select top(1) a.imageval from sys.sysobjvalues a where a.objid=@objectID and a.valclass=1)

rollback tran

-------------
set @tmpStr=stuff(@tmpStr,1,5,'create')
set @sql=''
set @i=1
while @i&lt;= (datalength(@imageval)/2)
begin
    set @sql=@sql+isnull(nchar(unicode(substring(@tmpStr,@i,1)) ^ unicode(substring(@tmpStr_imageval,@i,1))^unicode(substring(@imageval,@i,1)) ),'')
    Set @i+=1
end

/* 2. 列印 */

declare @patindex int
while @sql&gt;''
begin

    set @patindex=patindex('%'+char(13)+char(10)+'%',@sql)
    if @patindex &gt;0
    begin
        print substring(@sql,1,@patindex-1)
        set @sql=stuff(@sql,1,@patindex+1,'')
    end
    else
    begin
        set @patindex=patindex('%'+char(13)+'%',@sql)
        if @patindex &gt;0
        begin
            print substring(@sql,1,@patindex-1)
            set @sql=stuff(@sql,1,@patindex,'')
        end
        else
        begin
            set @patindex=patindex('%'+char(10)+'%',@sql)
            if @patindex &gt;0
            begin
                print substring(@sql,1,@patindex-1)
                set @sql=stuff(@sql,1,@patindex,'')
            end
            else
            begin
                print @sql
                set @sql=''
            end
        end
    end

end

Go
exec sp_ms_marksystemobject 'sp_DecryptObject' --标识为系统对象
go</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p> 如果SQL Server 2012，请修改下面两个位置的代码。方法类似于前面的加密过程：</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ185OTgzOWJjOWYwNmRmNWQ1MTQ0ZTMzMDJiNmM1ZjAwZC5qcGc=.jpg"></p>
<p> </p>
<p> </p>
<p><strong>搭建测试环境：</strong></p>
<hr>
<br />在一个测试环境中（DB: Test），先执行上面的加密存储过程（sp_EncryptObject）和解密存储过程（sp_EncryptObject）;再创建两个表：TableA &amp; TableB</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>use test
go
--创建表: TableA &amp; TableB
if object_id('myTableA') is not null drop table myTableA
if object_id('myTableB') is not null drop table myTableB
go
create table myTableA (ID int identity,data nvarchar(50),constraint PK_myTableA primary key(ID))
create table myTableB (ID int ,data nvarchar(50),constraint PK_myTableB primary key(ID))
go</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>接下来，我们要创建6个未加密的对象（对象类型包含 'P','V','TR','FN','IF','TF'）：</p>
<p> 1.视图（myView）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">View Code</p>
<pre>if object_id('myView') is not null drop view myView
go
create view myView
As
select * from TableA;
go</pre>
<p>2.触发器（MyTrigger）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">View Code</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>if object_id('MyTrigger') is not null drop Trigger MyTrigger
go
create trigger MyTrigger
on TableA
for update
As
 insert into TableB(ID,data) select a.ID,a.Data From Inserted a
go</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>3.存储过程（MyProc）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">View Code</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>if object_id('MyProc') is not null drop proc MyProc
go
create proc MyProc
(
  @data nvarchar(50)
)
As
insert into TableA(data) values(@data)
go</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>4.用户定义表值函数(TF)（MyFunction_TF）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">View Code</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>if object_id('MyFunction_TF') is not null drop function MyFunction_TF
go
create function MyFunction_TF
(
)
returns  @t table
(
    id int,
    data nvarchar(50)
)
As
begin
insert @t(id,data) select id,data from TableA
return
end
go</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>5.内联表值函数(IF) （MyFunction_IF）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">View Code</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>if object_id('MyFunction_IF') is not null drop function MyFunction_IF
go
create function MyFunction_IF
(
)
returns table
As
return(select top(3) id, data from TableA order by id desc)
go</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>6.标量函数(FN)（MyFunction_FN）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">View Code</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>if object_id('MyFunction_FN') is not null drop function MyFunction_FN
go
create function MyFunction_FN
(
)
returns nvarchar(50)
As
begin
return(select top(1) data from TableA order by id desc)
end
go</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p> </p>
<p> 当执行完了上面的1-6步骤的脚本，我们通过查询系统视图sys.sql_modules，可以看到未加密前的定义信息：</p>
<pre>select b.name as object,b.type,a.definition
    from sys.sql_modules a
        inner join sys.objects b on b.object_id=a.object_id
        where b.create_date&gt;=convert(date,getdate())
        order by b.object_id</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kNTY3OGIxOTgwNmY0MjExYzEzMWM5OWZjZWUyNDQ4My5qcGc=.jpg"></p>
<p> </p>
<p><strong>加密测试：</strong></p>
<hr>
<br /> </p>
<p>下面我就通过调用加密存储过程（sp_EncryptObject），一次性对它们进行加密：</p>
<pre>use test
go
exec sp_EncryptObject 'all'
go</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19iNzk5Y2U0MjY0MjFjMTE1OTg3MThiNDljNmMyNzdjYi5qcGc=.jpg"></p>
<p>当我们再查回系统视图sys.sql_modules，会发现definition列返回的是null值，说明定义内容已经给加密：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNDI0MDMwYWRlOGU4Y2Q0NDM4N2E2YmVhZjZhYjA2OS5qcGc=.jpg"></p>
<p> </p>
<p> <strong>解密测试：</strong></p>
<hr>
<br /> </p>
<p>解密过程，必须在DAC连接SQL Server，我们这里例子是从 SSMS(SQL Server Management Studio) 查询编辑器启动 DAC，如图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181YTQxNzFlNDQzNTAyN2Q4MmNmYjhmZTg2Y2I4ZTdiZC5qcGc=.jpg"></p>
<p> </p>
<p>解密存储过程（sp_DecryptObject），只能一次对一个存储过程、函数、视图或触发器，进行解密：</p>
<pre>use test
go
exec sp_DecryptObject MyTrigger
go</pre>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lNzFiNjBmYzYxNTY5OGU3ZTg3Y2M3YjFlMzg2OTg5ZC5qcGc=.jpg"></p>
<p>当定义内容长度超过4000，我们可以指定@MaxLength的值，如：</p>
<pre>exec sp_DecryptObject fn_My,20000
go</pre>
<p>这里（fn_My）是一个函数，定义内容超过了8000：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zODk1OTZlZmQzNDI4ZjQ1MGQ2YTM0ZmQ0Y2Y2MzdiZC5qcGc=.jpg"></p>
<p>... ...</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kYjEzYmFjNTQ0ZWQ3NzBjMjI3YWQwZjU5NzM0ZWY5NC5qcGc=.jpg"></p>
<p> </p>
<p><strong>小结：</strong></p>
<hr>
<br /> </p>
<p>虽然，上面的脚本，我已经在SQL Server 2008 R2 和SQL Server 2012测试过，但无法避免一些未知错误 。如果你自己在测试上面的脚本，请不要在生产环境上。如果你在应用过程，碰到有什么问题或有什么意见和建议可以发email联系我或跟帖，在此非常感谢！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 00:42:34</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%8a%a0%e5%af%86/" title="加密">加密</a>, <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8%e8%bf%87%e7%a8%8b/" title="存储过程">存储过程</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/create/" title="Create">Create</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/type/" title="type">type</a>, <a href="https://www.iamivan.net/tag/view/" title="view">view</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>对存储过程进行加密和解密(SQL 2008/SQL 2012)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6GB5Wp.html" rel="bookmark">SQL 存储过程加密与解密实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				存储过程加密很简单    代码如下 复制代码 USE test_db GO IF   EXISTS   (SELECT   name   FROM   sys.objects WHERE   name   =   'encrypt_this '   AND   type   =   'P ') DROP   PROCEDURE   encrypt_this GO   --创建存储过程并加密  代码如下 复制代码 CREATE   PROCEDURE   encrypt_this WITH   E			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9Mx85GM.html" rel="bookmark">sql server存储过程、存储函数的加密、解密</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|存储过程|函数|加密|解密 存储过程.存储函数的加密:WITH ENCRYPTION&lt;!--[if !supportLineBreakNewLine]--&gt;&lt;!--[endif]--&gt; CREATE procedure dbo.sp_XML_main @table_name nvarchar(260)='', @dirname nvarchar(20)='' WITH ENCRYPTION as begin ..............................			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bolwX3M.html" rel="bookmark">SQL Server储过程加密和解密原理深入分析&lowbar;mssql2008</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开始: -------------------------------------------------------------------------------- 在网络上,看到有SQL Server 2000和SQL Server 2005 的存储过程加密和解密的方法,后来分析了其中的代码,发现它们的原理都是一样的.后来自己根据实际的应用环境,编写了两个存储过程,一个加密存储过程(sp_EncryptObject),和一个解密存储过程(sp_EncryptObject),它们可以应用于S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKka4Lb.html" rel="bookmark">sql server 解密-请问Microsoft SQL Server 2005数据库中加密记录解密方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 请问Microsoft SQL Server 2005数据库中加密记录解密方法 请问Microsoft SQL Server 2005数据库中类似 0MHCkgK7c4E= 的记录(共12位)是使用什么算法加密得到的?能否提供解密的方式或网址,谢谢! 解决方案 有些用到了base64来加密			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9MxBdGz.html" rel="bookmark">MySQL字段加密和解密</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL字段加密和解密 1.加密:aes_encrypt('admin','key') 解密:aes_decrypt(password,'key') 2.双向加密 通过密钥去加密,解密的时候的只有知道这个密钥的人来解密 加密:encode() 解密:decode() eg:encode('123456' 'adfdgfdhggfh'); decode(password,'adfdgfdhggfh'); 3.PASSWORD('123456') password加密是不可逆转的 4.MD5('1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWOg1p.html" rel="bookmark">关于MD5加密与解密</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在ASP.NET项目如何将已经加密过的密码解密并且实现用户登陆 解决方案 解决方案二:不用解密.把用户输入的密码加密转换后,同数据库里保存的密码(同一用户名)比较就可以了.解决方案三:直接修改你的登录程序的逻辑,不判断密码直接统统判断验证成功就是了.解决方案四:md5是种单向的加密算法,一旦加密就没有办法解密.只能把用户输入的密码再次加密,看一下密文是不是一样的.解决方案五:为何要解密?正确做法是将用户的输入加密后和去数据库匹配.md5加密的结果解密那是科学家的事.解决方案六:网数据库			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRN2NBM.html" rel="bookmark">SQL 2008执行语句遇到内存不足（1）&mdash;&mdash;error 701</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL 2008执行语句遇到内存不足(1)--error 701 转自:http://blogs.msdn.com/b/apgcdsd/archive/2011/01/17/sql-2008-error-701.aspx 某个特定的存储过程在SQL 2008中执行会遇到以下错误: Msg 701, Level 17, State 123, Procedure GetAllRevisions_Monthly, Line 22 There is insufficient system memo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjjoRZb.html" rel="bookmark">SQL 2008执行语句遇到内存不足的案例&lpar;error 701&rpar;之一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SQL 2008执行语句遇到内存不足的案例(error 701)之一 某个特定的存储过程在SQL 2008中执行会遇到以下错误: Msg 701, Level 17, State 123, Procedure GetAllRevisions_Monthly, Line 22 There is insufficient system memory in resource pool 'internal' to run this query. Msg 701, Level 17, State 65,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YMRyOxb.html" rel="bookmark">采用Cipher DES针对文件加密、解密</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于经常用一些加密或者解密文件的,所以写了一个简单的采用Cipher DES针对文件加密.解密的工具类,记录一下,防止以后忘记了! import java.io.BufferedReader; import java.io.FileInputStream; import java.io.FileOutputStream; import java.io.InputStream; import java.io.InputStreamReader; import java.io.OutputStrea			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnyyrM.html" rel="bookmark" class="title">一个BBS的源代码&lpar;四&rpar;</a>
					<div>
						源代码 '=============================================================================================== ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1nKxp.html" rel="bookmark" class="title">超级留言本制作实例＜1＞</a>
					<div>
						做了几年的网页,到处留言千千万,用过各种留言本万万千.可惜令我喜欢的留言本真少(55555),慢慢的速度让我无法忍受,丑陋的界面让我心烦,图标更是让人作呕,所以我下决心写一个自己的超级留言本,阿余半夜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AwG6p.html" rel="bookmark" class="title">ASP编程入门进阶（3）：FSO组件之文件操作（上）</a>
					<div>
						学会了FSO提取文件值,也学会了将信息输入到文件中,那下面就再来应用应用下. 不知道你有没有这样的习惯:看到一个文件,不自觉的右键选择用记事本打开.呵呵,几乎没有哪个文件是不可以的.所以现在,可以默认 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVw0wkb.html" rel="bookmark" class="title">Word2007中怎么设置装订线</a>
					<div>
						  为了阅读方便,常常会把电子文档打印在纸张上,而如果多页文档打印,就要考虑把它装订起来,方便文档的保存.那么在打印之前,我们就需要对文档设置装订线,为文档保留出额外的空间,确保不会遮住文字. 1.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oWDmb.html" rel="bookmark" class="title">js创建表单元素并使用submit进行提交</a>
					<div>
						 js 创建form.input元素,并设置form的action及method,最后使用submit进行提交 01 &lt;script src=&quot;Scripts/jquery-1.7.1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4219JM.html" rel="bookmark" class="title">Win7系统分区教程</a>
					<div>
						  刚买的电脑一般硬盘都会只给你一个C盘分区,所以电脑拿回家第一件事一般就是进行硬盘分区.在Win7系统中已经自带了一款硬盘分区功能,使用起来非常简单.那么win7自带分区工具怎么用呢?下面就跟小编一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjV3Lb.html" rel="bookmark" class="title">安全狗怎么远程操作</a>
					<div>
						  1.&quot;服务器管理&quot;页面上,在需要进行安全狗软件远程操作的服务器条目上,点击安全狗软件远程操作按钮,如图所示: 2.安全狗软件远程操作提供包括ARP防火墙.DDoS防火墙.安全策 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZDN4b.html" rel="bookmark" class="title">网页上鼠标右键被锁定了怎么办？</a>
					<div>
						  其实,这是由于网页文件中被加入了如上一代码所示: 这样在浏览网页时除单击鼠标左键外,其他任何形式的鼠标点击或组合点击,都将出现&quot;版权所有(C),严禁复制!&quot;的提示框. 对于以上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaw0az.html" rel="bookmark" class="title">Get the Mime Type from a File</a>
					<div>
						原文:http://www.rgagnon.com/javadetails/java-0487.html Using javax.activation.MimetypesFileTypeMap act ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrEmWM.html" rel="bookmark" class="title">thinkphp-如何在控制器中跳转到页面的某个frame中</a>
					<div>
						问题描述 如何在控制器中跳转到页面的某个frame中 像a标签的target属性一样,在后台的php中跳转到前台的frame中. 我这边是两个frame框架,上面的frame是搜索框,下面的frame ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7weoz.html" rel="bookmark" class="title">mysql-phpmyadmin 不能显示数据怎么弄？</a>
					<div>
						问题描述 phpmyadmin 不能显示数据怎么弄? 解决方案 phpMyAdmin数据中文显示乱码 解决方案二: 造成这样的原因是因为权限不够,所以我们需要重新赋予一下权限,使用SSH工具输入cho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPaP8p.html" rel="bookmark" class="title">Android中调用系统所装的软件打开文件</a>
					<div>
						应用中如何调用系统所装的软件打开一个文件,这是我们经常碰到的问题,下面是我所用到的一种方法,和大家一起分享一下! 这个是打开文件的一个方法:   /** * 打开文件 * @param file */ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3kA5z.html" rel="bookmark" class="title">《基于ArcGIS的Python编程秘笈（第2版）》&mdash;&mdash;2&period;8　添加图层到地图文档</a>
					<div>
						本节书摘来自异步社区&lt;基于ArcGIS的Python编程秘笈(第2版)&gt;一书中的第2章,第2.8节,作者: [美]Eric Pimpler(派普勒) 更多章节内容可以访问&quot;异步社 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjnG7M.html" rel="bookmark" class="title">cocos2d x-天天德州 倒计时 用cocos2d怎么做</a>
					<div>
						问题描述 天天德州 倒计时 用cocos2d怎么做 像这种倒计时进度条用cocos2d应该怎么做...求具体方法!!! 解决方案 可以用一个计时器schedule来每秒调用一个函数(接受一个Ref*  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4Yooz.html" rel="bookmark" class="title">Apple Watch将失败&quest;为什么&quest;五大理由告诉你&excl;</a>
					<div>
						导读:Apple Watch预计上市初期销量不错,但是,从长期来看,Apple Watch将会面临失败,除非苹果能找到解决以下五大问题的方案. 五大理由暗示Apple Watch将失败 Techrad ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeV1jb.html" rel="bookmark" class="title">请问如何在LotusScript调用&commat;Command</a>
					<div>
						问题描述 我想在LotusScript中调用@Command,请问代码如何写? 解决方案 解决方案二:evaluate(|@xxxxx|,doc)解决方案三:楼上正解....解决方案四:LotusSc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKoAEb.html" rel="bookmark" class="title">javaweb-怎样循环输出下面的数据？</a>
					<div>
						问题描述 怎样循环输出下面的数据? &lt;c:forEach items=&quot;listArticle&quot;&gt; &lt;tr&gt; &lt;td bgcolor=&quot;#F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY51veM.html" rel="bookmark" class="title">网络实名制并非&OpenCurlyDoubleQuote;治标不治本&rdquo;</a>
					<div>
						「内容摘要」网络实名制一定是有利的.网络既然成了社会活动不可分割的组成部分,那么通过网络所进行的各种活动也就应该服从整个社会活动秩序.我不赞同有人说&quot;实名制&quot;治标不治本.正如人不能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd7vEb.html" rel="bookmark" class="title">小心家用路由器被&OpenCurlyDoubleQuote;劫持&rdquo;：厂商留有后门</a>
					<div>
						上网遇到广告弹窗,网页被跳转赌博网站;QQ网银无缘无故被盗--很多人不知道,这些作恶的源头多起于家中那台小小的路由器.记者调查发现,TP-Link.D-Link.腾达.网件等主流路由器品牌的多款产品, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKNRWz.html" rel="bookmark" class="title">iOS开发之GCD使用总结</a>
					<div>
						GCD是iOS的一种底层多线程机制,今天总结一下GCD的常用API和概念,希望对大家的学习起到帮助作用. GCD队列的概念 在多线程开发当中,程序员只要将想做的事情定义好,并追加到DispatchQu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeOqZM.html" rel="bookmark" class="title">ORA-12154 和 TNS-03505 监听错误的解决方法</a>
					<div>
						                                   ORA-12154 和 TNS-03505 监听错误的解决方法   今天在笔记本上本来想做个exp的测试的时候突然报错: ORA- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeELEM.html" rel="bookmark" class="title">一款圆柱形&OpenCurlyDoubleQuote;酒杯&rdquo;空调受到众多网友的追捧</a>
					<div>
						颠覆空调方方正正的造型,近日,一款圆柱形&quot;酒杯&quot;空调受到众多网友的追捧.网友&quot;走了个神&quot;在海尔社区发帖说,&quot;看到空调外形灵感来源于高贵的玛姆红带香槟, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjoOoM.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;木马下载器&rdquo;新变种近期出现</a>
					<div>
						摘要: 11月7日消息,国家计算机病毒应急处理中心通过监测发现,木马下载器新变种近期出现. 据了解,木马下载器新变种是通过联网获取配置文件,并劫持目前较为流行的第三方应用程序的 11月7日消息,国家计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXV4lb.html" rel="bookmark" class="title">雅虎新任CEO玛丽莎&CenterDot;梅耶尔</a>
					<div>
						雅虎新任CEO玛丽莎·梅耶尔 导语:国外媒体今天刊文称,谷歌前高管玛丽莎·梅耶尔(Marissa Mayer)本周被任命为雅虎新任CEO.梅耶尔出任雅虎CEO令人惊讶,而这也是雅虎在一年时间内更换的第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqymvp.html" rel="bookmark" class="title">php读取证书信息</a>
					<div>
						这些都是php自带函数 echo $_SERVER[&quot;CERT_FLAGS&quot;].&quot;&quot;;//使用证书的标识,1或0 echo $_SERVER[&quot;CER ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5WN7p.html" rel="bookmark" class="title">全栈工程师必备！Devops Tools 周期表</a>
					<div>
						老外整理的 Devops Tools 周期表,可以用酷炫屌炸天形容,划分了数据库.CI.日志.安全.监控.配置管理.云服务等15个大类,120个工具.有很人多都没全听说过,你要是全学会了你就是全栈工程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmLGap.html" rel="bookmark" class="title">javascript flash下fromCharCode和charCodeAt方法使用说明&lowbar;基础知识</a>
					<div>
						fromCharCode 方法 从一些 Unicode 字符值中返回一个字符串. String.fromCharCode([code1[, code2[, ...[, codeN]]]]) 参数 St ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOd9Jb.html" rel="bookmark" class="title">MySQL Order By语法介绍&lowbar;Mysql</a>
					<div>
						今天在使用ORDER BY的过程中出现了一点问题,发现之前对ORDER BY理解是错误的. 之前在w3s网站上看到ORDER BY的用法,以为是对选出来的数据按关键字升序或者降序排列,结果今天尝试se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL8JvM.html" rel="bookmark" class="title">解析php中的escape函数&lowbar;php技巧</a>
					<div>
						采用js对URL中的汉字进行escape编码. &lt;a href=&quot;&quot; onclick=&quot;window.open('product_list.php?p_sort=' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7vaEM.html" rel="bookmark" class="title">C&num;如何画出饼状图？</a>
					<div>
						问题描述 我想画一个饼状图来显示数据的比例?彩电20%冰箱40%空调40% 解决方案 解决方案二:应用GDI,自已写代码画参考:http://www.zxbc.cn/html/aspnet/20070 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
